/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   EZ_PRINT.C    \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Gestion de la fenetre Impression, et de tout ce qui s'y rapporte    */
 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le  */
                       /* que le module EAZY_GEM.LIB met  votre et     */
                       /* notre disposition                             */
                       /* et inclure les definitions des variables      */
                       /* globales  d'EAZY_GEM                          */
                       /* Je rappelle que le fichier EAZY_GEM.H et le   */
                       /* fichier EAZY_GEM.LIB doivent se trouver dans  */
                       /* les repertoires INCLUDE (pour le .H) et LIB   */
                       /* (pour le .LIB) de votre Pure C.               */
/* C'est  cause de cette ligne que vous avez le droit d'utiliser les   */
/* fonctions d'EAZY_GEM.                                                */
/* La lecture de ce fichier peut vous renseigner sur tout un tas de     */
/* choses. Il est toujours instructif de regarder les fichiers .H       */


#include "EZ_EDIT.SYS\EZ_MESSG.H"   /* definition du fichier de message */
/*................... inclure definition ressource .....................*/
#include "EZ_EDIT.SYS\EZ_PRINT.H"
#include "EZ_EDIT.H"
/*............... MACRO DE CONVERSION: DEC_TO_PIX.......................*/
/*          a = valeur en mm/c si donnee en mm     c = 1                */
/*                             si donnee en mm/10  c = 10               */
/*                             si donnee en mm/100 c = 100   etc...     */
/*          b = nbr de points par pouce du peripherique des pixels.     */
#define DEC_TO_PIX(a,b,c)  (float)(((float)(a)*(float)(b))/(float)(25.4*c))

/*............... MACRO DE CONVERSION: PIX_TO_DEC.......................*/
/*          a = valeur en pixels                                        */
/*          c = echelle resultat si voulu en mm     c = 1               */
/*                               si voulu en mm/10  c = 10              */
/*                               si voulu en mm/100 c = 100   etc...    */
/*          b = nbr de points par pouce du peripherique des pixels.     */
#define PIX_TO_DEC(a,b,c)  (float)((float)((a)*25.4*(float)(c))/(float)(b))

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#define WM_PRTINIT       5567
#define ENTETE_PG        1
#define PIED_PG          2
typedef struct
       {char            sDevNum[4];
        char            sDrvName[40];
        int             ResX;
        int             ResY; 
        int             PpiX;
        int             PpiY;   
        int             NbVect;  
        int             NumDev;  
        } DRVINF;

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*.......................PUBLIQUES .....................................*/
extern char             **TxtPtStrMess;

/*........................ PRIVEES .....................................*/
static long             PtPage        = 0;
static DRVINF           DrvInf[40];
static int              NbDrv         = 0;
static char             sGemFile[14]  = "GEMFILE.GEM"; 
static GRECT            PgGrect;
static char             BadScan[30]   = ";<=>?@ABCDGHKMPRTUVWXYZ[\]ab"; 
static int              CurPrtDoc     = -1;
static int              NbLgnParPage  = -1;
static int              Prt_Intl      = -1;
static long             NbPage        = -1;
static double           Ratiox        = 1;
static double           Ratioy        = 1;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*......................... PUBLIQUES ..................................*/
CALLBACK WindProc_PRT(int w_ind, EVNT_O *Evnt); /* FENETRE PARAM.   */
void     RedrawPrintMiniPage(void);
/*......................... PRIVEES ....................................*/
long    GetNbLgnParPageTxt(int drv, int *pt_lgh);
long    GetLastPageTxt(int w_ind);
char   *GetTxtHead(void);
char   *GetTxtFoot(void);
int     LargeurTexte(char *txt, TXTED_OB *TXT_A);
int     PrintTextFootHead( int vdi_h, char *txt, int  tx, int  ty, int page, 
                           TXTED_OB *TXT_A, TXT_GFG *ptTxtCfg, GRECT *grect);
void    UpdateLghNbLgn(int w_ind, OBJECT *object, int redraw_flag);
static  int CallBackScrollDrv(SCROLLBOX_GET_AFFI *SCRL);
static  void SetInfoDrvStr(OBJECT *object, int ob_ind, int i);
DRVINF  *ScanDrivers(int *nb_drv);
int     Swpeek(long adr);
int     Analyse_ASSIGN(DRVINF *drvinf);
int     Releve_DRIVER(char *ptc, DRVINF *drvinf);
char    *ExtraitWord( char *dest, char *ptr,int *nbr_car);
char    *Ligne_suivante(char *ptr);
int     AdjustPtspar1000ToPPI(int pt_1000);
int     AdaptPgPAINTBOXtoResXetY(OBJECT *object, int ind_ob, GRECT *pggrect, int drv);
void    ImprimerPage(int wind_target, int drv, int pg_deb, int pg_end, int nb);
int     TesteDriver(int drv, DRVINF *drvinf);
void   *Bload( char *path, char *name, void *adr_load);
long    LirePage(int wind_target, int vdi_h, int page, GRECT *grect);
int     PrintColorLigne(int vdi_h, long i, int tx, int ty, TXTED_OB *TXT_A, TXT_GFG *ptTextCfg, GRECT *grect);
int     PrintColorBaliseTxt(int tx, int ty, char *PtTexteLigne, TXTED_OB *TXT_A, GRECT *grect);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*-----------------------------ImprimerPage---------------------------------------*/
void ImprimerPage(int wind_target, int drv, int pg_deb, int pg_end, int nb)
{int p_in[11],p_out[57], w_ind;
 int vdi_h;
 int n, v_ok;
 OBJECT *object;
 int i;
 GRECT grect, grectv; 
 char buft[32];

 /*............ initialiser station travail ...................*/
 for (i=1;i<10;p_in[i++]=1);
 p_in[10] =2;
 p_in[0]  = DrvInf[drv].NumDev;       /* Numro du prif  tester         */
 v_opnwk(p_in, &vdi_h, p_out);        /* ouvre la station de l'imprimante */
 /*........... effacer eventuel fichier"GEMFILE.GEM"......................*/
 if (DrvInf[drv].NumDev>=31 && DrvInf[drv].NumDev<=40) 
    {nb = 1;
     Fdelete(sGemFile); 
    }
 if (DrvInf[drv].NumDev>=91 && DrvInf[drv].NumDev<=100) 
    {nb = 1;
    }   
 /*.......... se mettre en option base zero ..............................*/
 pg_deb = Min( (int)GetLastPageTxt(wind_target), Max(0, pg_deb) );
 pg_end = Min( (int)GetLastPageTxt(wind_target), Max(0, pg_end) );
 /*.......... recuperer rectangle paint box ..............................*/
 w_ind = IsWindExist(W_EZ_EDIT_PRT);
 if (w_ind !=-1 && IsWindOpen(w_ind))
    {object = GETWINDTREE(w_ind);
     v_ok   = 0;
     if (!(object[PRT_ONG_CADRAGE].ob_flags & HIDETREE))
        {grectv = *(GRECT*)&object[PRT_PAINTBOX_RED].ob_x;
         objc_offset(object,PRT_PAINTBOX_RED, &grectv.g_x, &grectv.g_y);
         v_ok = PRT_ONG_CADRAGE;
        }                      
     if (!(object[PRT_ONG_REDUIRE].ob_flags & HIDETREE))    
        {grectv = *(GRECT*)&object[PRT_PAGEPAINTBOX].ob_x;
         objc_offset(object,PRT_PAGEPAINTBOX, &grectv.g_x, &grectv.g_y);
         v_ok = PRT_ONG_REDUIRE;
        }        
     grectv.g_x += 5;
     grectv.g_y += 4;
     grectv.g_w -= 10;
     grectv.g_h -= 9;
    }
 
 /*................. Si driver dispo pour ce numero ......................*/
 if (vdi_h )
    {vst_load_fonts(vdi_h,0);
     /*.................. rectangle imprimante ...........................*/
     grect.g_x = 0; 
     grect.g_y = 0;
     grect.g_w = DrvInf[drv].ResX;
     grect.g_h = DrvInf[drv].ResY;
     
     /*.....................corriger eventuelle erreur deb_page .......................*/
     ObjcSetTxt (object, PRT_PG_DEB, AsciiNumberToLedNumber(itoa(pg_deb+1,buft,10)) );
     if (!v_ok) Xobjc_draw (object, PRT_PG_DEB, 1, 0);
     /*............. afficher les pages suivantes .....................................*/
     for (i=pg_deb; i<=pg_end; i++) 
         {ObjcSetTxt (object, PRT_PG_TXTCADR, itoa(i+1,buft,10) ); 
          if (v_ok)
             {if(v_ok==PRT_ONG_CADRAGE) Xobjc_draw (object, PRT_PG_TXTCADR, 1, 0);  
              ClipGrect(&grectv); 
              Deffill(8,2,4);                  
              Defline(1,1,0,0,1);
              Graphmode(MD_REPLACE);
              GrectPbox(&grectv);                                       
              LirePage(wind_target, VDIhandle, i, &grectv); /* afficher la vue reduite  */        
             }             
          LirePage(wind_target, vdi_h, i, &grect);       /* imprimer la page         */
          /*....... imprimer tous les exemplaires ......*/   
          for (n=0; n<nb; n++) v_updwk(vdi_h);
         }
                
     /*......... effacer la page de la memoire ....*/
     v_clrwk(vdi_h);                     /* effacer station imprimante            */
     PtPage = pg_end;
     vst_unload_fonts(vdi_h,0);
     v_clswk(vdi_h);
     }
}

/*------------------------- GetTxtHead -----------------------------------*/
char *GetTxtHead(void)
{int w_ind = IsWindExist(W_EZ_EDIT_PRT);
 if (w_ind !=-1 && IsWindOpen(w_ind))
    {OBJECT* object = GETWINDTREE(w_ind);
     return ObjcGetTxt (object, PRT_HEADEDIT);
    }
 return 0;
}
/*------------------------- GetTxtFoot -----------------------------------*/
char *GetTxtFoot(void)
{int w_ind = IsWindExist(W_EZ_EDIT_PRT);
 if (w_ind !=-1 && IsWindOpen(w_ind))
    {OBJECT* object = GETWINDTREE(w_ind);
     return ObjcGetTxt (object, PRT_FOOTEDIT);
    }
 return 0;
}
/*------------------------- PrintTextFootHead --------------------------------*/
int PrintTextFootHead( int vdi_h, char *txt, int  tx, int  ty, int page, 
                        TXTED_OB *TXT_A, TXT_GFG *ptTxtCfg, GRECT *grect)
{char buftext[1024];
 char buft[32];
 int sav_h          = VDIhandle;
 int my_date        = Tgetdate();
 char *pt_deb       = txt;
 char *pt_end       = txt;
 CAR_ATTR *sav      = TXT_A->ATT_Cur;
 int justif         = ALI_LEFT; /* horizontal text alignment */
 
 TXT_A->ATT_Cur     = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
 if (txt==0 || *txt==0) goto exit_print_head;
 buftext[0]         = 0;
 VDIhandle          = vdi_h;
  while(pt_end && *pt_end)
   {/*......... si fin de ligne imprimer le buffer .......*/
    if (*pt_end==13 || *pt_end==10)
       {char sav_c = *pt_end;
        *pt_end    = 0;
        strcat(buftext, pt_deb);
        if (justif==ALI_CENTER)
           {int wtxt = LargeurTexte(buftext, TXT_A);
            tx = (DrvInf[DrvSel].ResX-wtxt)>>1;
           }
        else if (justif==ALI_RIGHT)
           {int wtxt = LargeurTexte(buftext, TXT_A);
            tx =  DrvInf[DrvSel].ResX - wtxt;
           }
        else
           {tx = 2;
           }
        PrintColorBaliseTxt( tx, ty, buftext, TXT_A, grect);
        ty        += Prt_Intl;
        *pt_end    = sav_c;
        pt_deb     = GotoNextLigne(pt_end);
        pt_end     = pt_deb;
        buftext[0] = 0;
       }
    else if (*pt_end=='#')
       {char sav_c = *pt_end;
        *pt_end    = 0;
        strcat(buftext, pt_deb);
        *pt_end    = sav_c;
        pt_end++;
        switch (*pt_end)
         {case 'C':  /* CENTER       */
               justif = ALI_CENTER;
               break;
          case 'R':  /* RIGHT        */
               justif = ALI_RIGHT;
               break;
          case 'L':  /* LEFT         */
               justif = ALI_LEFT;
               break;
          case 'P':  /* PATH         */
               strcat(buftext, ptTxtCfg->PathTxt);
               break;
          case 'F':  /* FILE         */
               strcat(buftext, ptTxtCfg->NomTxt);
               break;
          case 'N':  /* NUM_PAGE     */
               strcat(buftext, itoa(page+1, buft, 10));
               break;
          case 'J':  /* JOUR         */
          case 'D':  /* DAY          */
               strcat(buftext, itoa( my_date& 31, buft, 10));
               break;
          case 'M':  /* MONTH MOIS   */
               strcat(buftext, itoa( (my_date>> 5)&15, buft, 10));
               break;
          case 'A':  /* ANNEE        */
          case 'Y':  /* YEAR         */
               strcat(buftext, itoa( (my_date>> 9)+1980, buft, 10));
               break;
         }
        while (*pt_end && *pt_end != ' '  && *pt_end != 10 && *pt_end != 13 && *pt_end != '#') pt_end++;
        if (*pt_end=='#')pt_end++;
        pt_deb = pt_end;
       }
    else
       {pt_end++;
       }
    } /* end while(pt_end && *pt_end) */
 /*........... si il reste des caracteres les imprimer ............*/
    {char sav_c = *pt_end;
     *pt_end    = 0;
     strcat(buftext, pt_deb);
     if (justif==ALI_CENTER)
        {int wtxt = LargeurTexte(buftext, TXT_A);
         tx = (DrvInf[DrvSel].ResX-wtxt)>>1;
        }
     else if (justif==ALI_RIGHT)
        {int wtxt = LargeurTexte(buftext, TXT_A);
         tx =  DrvInf[DrvSel].ResX - wtxt;
        }
     else
        {tx = 2;
        }
     PrintColorBaliseTxt( tx, ty, buftext, TXT_A, grect);
     ty        += Prt_Intl;
     *pt_end    = sav_c;
    }
 exit_print_head:
 VDIhandle      = sav_h;
 TXT_A->ATT_Cur = sav;
 return ty;
}

/*------------------------- LargeurTexte ---------------------------------*/
int LargeurTexte(char *txt, TXTED_OB *TXT_A)
{extern int EZ_font, EZ_point; /* declaree dans EAZY_GEM.C              */
 EXTND_DIM strdim;
 int size = Max(1, (int)((double)PrtSizeFont*Ratioy) );
 if (*txt==0) return 0;
 /*.............. placer les attributs courants ............................*/
 EZ_font = EZ_point = -3; 
 Deftext(TXT_A->ATT_Cur->CarCol,                     /* couleur */
         TXT_A->ATT_Cur->CarEff,                     /* effet   */
         0,                                          /* angle   */
         size,                                       /* taille  */
         VdiFntId                                    /* fonte   */
        );
 if (Gdos == '_FSM')
    {vqt_f_extent(VDIhandle,txt,(int*)&strdim);
    }
 else
    {vqt_extent(VDIhandle,txt,(int*)&strdim);
    }
 return strdim.XinfD - strdim.XinfG;
}

/*------------------------- LirePage -------------------------------------*/
long LirePage(int w_ind, int vdi_h, int page, GRECT *grect)
{long fst_lgn, der_lgn, i;
 int mrg_l, mrg_t, mrg_r, mrg_b;
 int tx            = 0;
 int ty            = 0;
 int ident         = GETWINDIDENT(w_ind);
 TXTED_OB  *TXT_A  = 0;
 TXT_GFG *ptTxtCfg = 0;
 if (!IS_IDWINDTXT(ident))            return -1L;
 TXT_A             = WTXT_A(w_ind);
 ptTxtCfg          = WTXT_CFG(w_ind);
 fst_lgn           = NbLgnParPage * Max(0, page);
 /*.................. ratio de representation ..........................*/
 /*         (rapport entre vue reduite et taille normale)               */
 Ratiox = (double)grect->g_w / (double)DrvInf[DrvSel].ResX;
 Ratioy = (double)grect->g_h / (double)DrvInf[DrvSel].ResY;
 Mouse_off();              /* maintenant on cache la souris */
/*............... imprimer entete ......................................*/
 if (PrtHead)
    {PrintTextFootHead( vdi_h, GetTxtHead(), 0, Prt_Intl, page,
                        TXT_A, ptTxtCfg, grect);
    }
/*............... MACRO DE CONVERSION: DEC_TO_PIX.......................*/
/*          a = valeur en mm/c si donnee en mm     c = 1                */
/*                             si donnee en mm/10  c = 10               */
/*                             si donnee en mm/100 c = 100   etc...     */
/*          b = nbr de points par pouce du peripherique des pixels.     */
/* #define DEC_TO_PIX(a,b,c)  (float)(((float)(a)*(float)(b))/(float)(25.4*c))  */
 
 mrg_l = DEC_TO_PIX( MrgLeft,   DrvInf[DrvSel].PpiX, 10);
 mrg_t = DEC_TO_PIX( MrgTop,    DrvInf[DrvSel].PpiY, 10);
 mrg_r = DEC_TO_PIX( MrgRight,  DrvInf[DrvSel].PpiX, 10);
 mrg_b = DEC_TO_PIX( MrgBottom, DrvInf[DrvSel].PpiY, 10);
 ty   += mrg_t;
 tx   += mrg_l;
 mrg_r++; mrg_b++; /* calmer le compil */

 /*.............. placer flag impression entete ...............................*/
 der_lgn = Min(fst_lgn + NbLgnParPage, TXT_A->NbLgn);
 for (i=fst_lgn; i<der_lgn; i++)
     {PrintColorLigne(vdi_h, i, tx, ty, TXT_A, ptTxtCfg, grect);
      ty += Prt_Intl;
     }
 /*............... imprimer Pied de page ................................*/
 
 if (PrtNoteFoot)
    {PrintTextFootHead( vdi_h, GetTxtFoot(), 0, ty, page,
                        TXT_A, ptTxtCfg, grect);
    }
 Mouse_on();  /* maintenant on montre la souris */
 return 0;
}


/*-------------------------- PrintColorLigne ---------------------------------*/
int PrintColorLigne(int vdi_h, long i, int tx, int ty, TXTED_OB *TXT_A, TXT_GFG *ptTxtCfg, GRECT *grect)
{
#pragma warn -pia   /* Possible incorrect assignment. */
 int sav_h           = VDIhandle;
 int d;
 char *affi_buff     = TXT_A->AffiBuff;
 char *pt_dst        = affi_buff;
 char *pt_src        = TXT_A->TabLgnCtx[i].ptTxt;
 LGN_STAT* lgn_stat  = (LGN_STAT*)TXT_A->SupLgnCtxtMem;
 int  isInSection    = 0;
 int  isInkwSection  = 0;
 int    tab          = TXT_A->ExpTAB;
 int    pos          = 0;
 int    idgrclass    = 0;
 int    nb_car       = 0;
 int   intGrClass    = 0;
 /*...... relever parametres de syntaxe colore associe  ce texte ........*/
 SYNT_PARAM *syntprm   = ptTxtCfg->SyntPrm;
 KWSECTION  *kwsection;
 char *beg_tab;
 char *end_tab;
 char *kwbeg_tab;
 char *kwend_tab;
 char *validTab;
 /*............ positionner les attributs graphiques .......................*/
 vst_alignment (vdi_h, ALI_LEFT, ALI_BASE, &d, &d);   
 VDIhandle           = vdi_h;
 /*............ Si edition active et affi de la ligne en edition ...........*/
 if ( i == TXT_A->LigPt )
    {pt_src = TXT_A->BuffEdit;            /* on affiche le buffer de saisie */
    }
 else
    {pt_src = TXT_A->TabLgnCtx[i].ptTxt;  /* on affiche le texte normal     */
    }
 
 /*.............. Si numero de ligne positionn ............................*/
 if (TXT_A->ATT_Def[ATT_TXT_NUM_LGN].CarCol>-1)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
     PrintColorBaliseTxt( tx+2, ty, ltoa(i, "                                ", 10), TXT_A, grect) ;
    }
 /*................ SI pas de syntaxe colore imprimer en monochrome .......*/
 /**/
 if (syntprm==0)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
     while (*pt_src && *pt_src != 13 && *pt_src != 10)
           {if (*pt_src == '\t')
               {int fill = tab - (pos % tab);
                while (fill--) *pt_dst++ = ' ';
                pos += tab - (pos % tab);
                if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
                   {pt_dst[-tab] = TXT_A->CharTAB;
                   } 
                pt_src++;
               }
            else 
               {*pt_dst++ = *pt_src++;
                pos++;
               }
           } /*endwhile (*pt_src && *pt_src != 13 && *pt_src != 10) */
     *pt_dst   = 0;
     PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
     VDIhandle = sav_h;
     return 1;
    }
 /*................. SINON imprimer en couleur .............................*/
 /**/
 kwbeg_tab         = syntprm->KwSectBegFirstCar;
 kwend_tab         = syntprm->KwSectEndFirstCar;
 /* tx += TXT_A->MargLeft * DrvInf[DrvSel].PpiX / 91;Prt_Intl */
 tx += TXT_A->MargLeft * Prt_Intl / TXT_A->IntLg;
 /*....... relever etat de la ligne .......................................*/
 if (i) 
    {isInSection   = lgn_stat[i-1].LgnState;
     isInkwSection = lgn_stat[i-1].KwSection;
    }
 /*............ initialisation des variables ...............................*/
 kwsection         = &syntprm->KwSection[isInkwSection];
 intGrClass        = kwsection->IntGrClass;
 if       (isInSection)  TXT_A->ATT_Cur = kwsection->SectionAdr[isInSection].CarAtt;
 else                    TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
 validTab          = kwsection->ValidChar;
 beg_tab           = kwsection->BegSection;
 end_tab           = kwsection->EndSection;
 
 /*............ analyser la ligne ..........................................*/    
 while (*pt_src && *pt_src != 13 && *pt_src != 10)
  {   /* TABULATION */
   if (*pt_src == '\t')
      {int fill = tab - (pos % tab);
       while (fill--) *pt_dst++ = ' ';
       pos += tab - (pos % tab);
       if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
          {pt_dst[-tab] = TXT_A->CharTAB;
          } 
       pt_src++;
      }
      /* END SECTION */
   else if (isInSection )
      {if ( end_tab[*pt_src] &&
           (nb_car = IsEndSection(pt_src, &isInSection, isInkwSection, syntprm)) 
          )
          {/*........ afficher le texte avant ..........*/
           FAST_CHARNCPY(pt_src, pt_dst, nb_car); /* met le zero de fin */
           tx            += PrintColorBaliseTxt(tx,  ty, affi_buff, TXT_A, grect);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           pt_src        += nb_car;
           pos           += nb_car;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++      = *pt_src++;
           pos++;
          }
      }
   else
      {/* NUMERIC */
       if (kwsection->NumCarBeg[*pt_src]                         &&
           BeforeIsValid(pt_src, i, kwsection->NumCar, TXT_A)
          )
          {nb_car = (int)IS_NUMERIC(pt_src+1, kwsection->NumCar);
           /*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*...... recuperer attribut graphique de la valeur numerique ...*/
           if (kwsection->NumBegGrClass!=kwsection->NumGrClass)
              {*affi_buff     = *pt_src;
               affi_buff[1]   = 0;
               TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumBegGrClass].AttGr;
               tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
               if (nb_car)
                  {FAST_CHARNCPY(pt_src+1, affi_buff, nb_car);
                   TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
                   tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
                  }
              }
           else
              {TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
               /*........ afficher la valeur numerique ...........*/
               FAST_CHARNCPY(pt_src, affi_buff, nb_car+1);
               tx                += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
              }
           nb_car++;     /* tenir compte de l'introducteur  */
           /*........ avancer positions ...............*/
           pt_src            += nb_car;
           pos               += nb_car;
           
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       
       /* KEYWORD */
       else if ( validTab[*pt_src]                && /* si IS_C_NAME(pt_src)  len = au minimum 1 */
                 BeforeIsValid(pt_src, i, validTab, TXT_A)
               ) 
          {KEY_WRD key_input, *key_result;
           nb_car           = CPY_STR_TO_TEST(pt_src, key_input.Name, (long)validTab);
           key_input.LenKey = nb_car;
           key_result       = (KEY_WRD*)bsearch(&key_input,
                                                 kwsection->KwAdr,
                                                 kwsection->NbKeyW,
                                                 sizeof(KEY_WRD),
                                                 NewKeyWordCompare
                                               );
           if (key_result)
              {/*........... afficher le texte avant .......................*/
               *pt_dst        = 0;
               tx            += PrintColorBaliseTxt( tx,  ty, TXT_A->AffiBuff, TXT_A, grect); 
               /*........... afficher le texte du mot clef .................*/
               TXT_A->ATT_Cur = &syntprm->GrClass[key_result->GraphClass].AttGr;
               tx            += PrintColorBaliseTxt( tx,  ty, key_result->Name, TXT_A, grect);
               /*........... si mot clef = fin de section ..................*/
               if (kwsection->MajMin & 4)
                  {isInkwSection      = 0;
                   kwsection          = &syntprm->KwSection[isInkwSection];
                   intGrClass         = kwsection->IntGrClass;
                   validTab           = kwsection->ValidChar;
                   beg_tab            = kwsection->BegSection;
                   end_tab            = kwsection->EndSection;
                  }
               TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
               pt_dst         = affi_buff;
              }
           else
              {
               /*FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);*/
               memcpy(pt_dst, pt_src, nb_car); 
               pt_dst        += nb_car;
               /*tx            += PrintColorBaliseTxt( tx,  ty, key_input.Name, TXT_A);*/
              }
           pt_src   += nb_car;
           pos      += nb_car;
          }
       /* BEG SECTION */
       else if ( beg_tab[*pt_src] &&
                (nb_car = IsBegSection(pt_src, &isInSection, &idgrclass, isInkwSection, syntprm))
               )
          {/*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += PrintColorBaliseTxt(tx,  ty, affi_buff, TXT_A, grect);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);
           /*memcpy(pt_dst, pt_src, nb_car); */
           pt_dst        += nb_car;
           pt_src        += nb_car;
           pos           += nb_car;
          }
       /* BEG KW_SECTION */
       else if (isInkwSection == 0   &&
                kwbeg_tab[*pt_src]   &&
                (nb_car = IsBegKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {
           /*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           tx               += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* END KW_SECTION */
       else if (isInkwSection       &&
                kwend_tab[*pt_src]  &&
                (nb_car = IsEndKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {
           /*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           tx                += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* OPERATOR */
       else if ( (idgrclass = IS_C_OPP(pt_src, kwsection->Operator))
               )
          {/*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*........ afficher le '(' ..................*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           *pt_dst++      = *pt_src++;
           pos++;
           /*.......... petite optimisation pour si suite pareille ..........*/
           while (                         /* SI espace ou operateur de meme couleur   */
                   (*pt_src==' '  ||
                    (idgrclass  == IS_C_OPP(pt_src, kwsection->Operator))
                   )
                  &&
                   (!kwend_tab[*pt_src] && /* et pas ne fin de section de mot clef     */
                    !kwbeg_tab[*pt_src] && /* et pas un debut de section de mot clef   */
                    !beg_tab[*pt_src]   && /* et pas un debut de section classique     */
                    !validTab[*pt_src]     /* et pas un debut de mot clef              */
                   )
                 )
              {*pt_dst++  = *pt_src++;
                pos++;
              }
           *pt_dst        = 0;
           tx            += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++ = *pt_src++;
           pos++;
          }
      }
  }/* endwhile */
 *pt_dst   = 0;
 tx       += PrintColorBaliseTxt( tx,  ty, affi_buff, TXT_A, grect);
 VDIhandle = sav_h;
 return 1;
#pragma warn .pia
} 

/*-------------------------- PrintColorBaliseTxt ----------------------------*/
/* ACTION: affiche le contenu d'un buffer avec les attributs courants.       */
/* ENTREE: int tx, int ty: position d'affichage en pixels.                   */
/*         char *buft: chaine  afficher.                                    */
/*         TXTED_OB *TXT_A: structure de definition des parametres.          */
/* RETOUR: largeur de ce qui vient d'etre affiche.                           */

int PrintColorBaliseTxt(int tx, int ty, char *PtTexteLigne, TXTED_OB *TXT_A, GRECT *grect)
{extern int EZ_font, EZ_point; /* declaree dans EAZY_GEM.C              */
 EXTND_DIM strdim;
 int color = 1;
 int size  = Max(1, (int)((double)PrtSizeFont*Ratioy) );
 if (*PtTexteLigne==0) return 0;
 if (IsPrtColor) color = TXT_A->ATT_Cur->CarCol;
 /*.............. placer les attributs courants ............................*/
 EZ_font = EZ_point = -3; 
 Deftext(color,                                      /* couleur */
         TXT_A->ATT_Cur->CarEff,                     /* effet   */
         0,                                          /* angle   */
         size,                                       /* taille  */
         VdiFntId                                    /* fonte   */
        );
 /*............. mesurer ce qui va etre affiche ............................*/
 tx = (int)((double)tx*Ratiox);
 ty = (int)((double)ty*Ratioy);
 if (Gdos == '_FSM')
    {vqt_f_extent(VDIhandle,PtTexteLigne,(int*)&strdim);
     v_ftext(VDIhandle, grect->g_x+tx , grect->g_y+ty, PtTexteLigne );
    }
 else
    {vqt_extent(VDIhandle,PtTexteLigne,(int*)&strdim);
     v_gtext(VDIhandle, grect->g_x+tx , grect->g_y+ty, PtTexteLigne ); 
    }
 return strdim.XinfD - strdim.XinfG;
}    
                 
/*------------------------------ GetLastPageTxt ----------------------------*/
long GetLastPageTxt(int w_ind)
{TXTED_OB  *TXT_A    = WTXT_A(w_ind);
 long last_page      = (TXT_A->NbLgn / NbLgnParPage)-1;
 if (last_page * NbLgnParPage<TXT_A->NbLgn) last_page++;
 return last_page;
}
/*------------------------------ GetNbLgnParPageTxt ----------------------------*/
long GetNbLgnParPageTxt(int drv, int *pt_lgh)
{extern int EZ_font, EZ_point; /* declaree dans EAZY_GEM.C              */
 int i, vdi_h, lgh;
 int p_in[11],p_out[57];
 int mrg_t = DEC_TO_PIX( MrgTop,    DrvInf[DrvSel].PpiY, 10);
 int mrg_b = DEC_TO_PIX( MrgBottom, DrvInf[DrvSel].PpiY, 10);
 EXTND_DIM strdim;
 

 /*............ initialiser station travail ...................*/
 for (i=1;i<10;p_in[i++]=1);
 p_in[10] =2;
 p_in[0]  = DrvInf[drv].NumDev;       /* Numro du prif  tester         */ 
 v_opnwk(p_in, &vdi_h, p_out);        /* ouvre la station de l'imprimante */
 if (vdi_h )                        
    {vst_load_fonts(vdi_h,0);
     /*............... initialiser le texte ..........................*/
     vst_font     (vdi_h, VdiFntId);
     vst_rotation (vdi_h, 0);
     vst_effects  (vdi_h, 0);
     vst_color    (vdi_h, 0);
     vst_point    (vdi_h, PrtSizeFont, &i, &i, &i, &i);
     if (Gdos == '_FSM') vqt_f_extent (vdi_h, "M", (int*)&strdim);
     else                vqt_extent   (vdi_h, "M", (int*)&strdim);
     vst_unload_fonts(vdi_h,0);
     v_clswk(vdi_h);
     lgh = (strdim.YsupD - strdim.YinfD);
     if (pt_lgh) *pt_lgh = lgh;
     return ( (DrvInf[drv].ResY-mrg_t-mrg_b) / lgh);
    }
 return -1;
}
/*------------------------------ UpdateLghNbLgn --------------------------*/
void UpdateLghNbLgn(int w_ind, OBJECT *object, int redraw_flag)
{char buft[32];
 itoa(NbLgnParPage, buft,10);
 ObjcSetTxt (object, PRT_NBLGN, buft );
 if (redraw_flag)
    {Wobjc_draw (w_ind, object, PRT_NBLGN, 1, 0);
    }
}
/*------------------------------ WindProc_PRT ----------------------------*/
/* ACTION: gestion de la fenetre document (principale) de diderot         */

CALLBACK WindProc_PRT(int w_ind, EVNT_O *Evnt)
{int w_h;
 char buft[64];
 DLG_VAR *dlg   = &Windtab[w_ind].DlgVar;       /* structure attachee  chaque ressource en fenetre */
 OBJECT *object = GETWINDTREE(w_ind);
 int wind_targ  = IsWindExist(CurIDDoc); 
 
 /*........recuperer handle GEM de notre fenetre ...................*/ 
 w_h = Windtab[w_ind].w_h;
 
 /*.......................... Rpondre  l'vnement MU_KEYBD .........*/ 
 if (Evnt->evnt & MU_KEYBD)
    {int ob_ind,i;
     char scan;
     char *txt;
     scan = (char)(Evnt->key>>8);  /* scan code touche clavier */
     Xform_keybd(w_ind, Evnt);
     ob_ind = dlg->ObjEdit;        /* noter editable en cours  */
     switch(ob_ind)
       { case PRT_SIZE_FONT:
         case PRT_PG_TXTCADR:
              WSetCursObEditOff(w_ind, 0);
              txt = ObjcGetTxt (object, ob_ind);
              i   = atoi( txt);
              if (ob_ind ==PRT_SIZE_FONT)  
                 {PrtSizeFont  = Min(120, i);
                  PrtSizeFont  = Max(6,PrtSizeFont);
                  if (i != PrtSizeFont)
                     {ObjcSetTxt (object, PRT_SIZE_FONT, itoa(PrtSizeFont, buft,10));
                      Wobjc_draw (w_ind, object, PRT_SIZE_FONT, 1, 0);
                     }
                  NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                  NbPage          = GetLastPageTxt(wind_targ)+1;
                  ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                  Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                  if (PtPage > NbPage)
                     {PtPage = NbPage;
                      ObjcSetTxt (object, PRT_PG_TXTCADR, ltoa(PtPage+1, buft,10));
                      Wobjc_draw (w_ind, object, PRT_PG_TXTCADR, 1, 0); 
                     }
                 }
              if (ob_ind ==PRT_PG_TXTCADR) 
                 {PtPage = Max(0, Min (i - 1 , GetLastPageTxt(wind_targ)));
                  if (i+1 != PtPage)
                     {ObjcSetTxt (object, PRT_PG_TXTCADR, ltoa(PtPage+1, buft,10));
                      Wobjc_draw (w_ind, object, PRT_PG_TXTCADR, 1, 0);
                     }
                 }
              UpdateLghNbLgn(w_ind, object, 1);
              RedrawPrintMiniPage();
              break;
         case PRT_MRG_LEFT:         /* Si marges                */
         case PRT_MRG_TOP:          /* alors filtrer redraw     */  
         case PRT_MRG_RIGHT:
         case PRT_MRG_BOTTOM:   
             {if (!strchr(BadScan,scan))
                 {strcpy( buft, ObjcGetTxt (object, ob_ind) );
                  i = atoi( LedNumbertoAsciiNumber(buft));
                  i = Max(0, Min(10000, i));
                  if (ob_ind == PRT_MRG_LEFT)   MrgLeft   = i;
                  if (ob_ind == PRT_MRG_TOP)    MrgTop    = i;
                  if (ob_ind == PRT_MRG_RIGHT)  MrgRight  = i;
                  if (ob_ind == PRT_MRG_BOTTOM) MrgBottom = i;
                  /*....redessiner les pages vues reduites ........*/
                  NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                  /*....... actualiser le nombre de pages .........*/
                  if (wind_targ != -1)
                     {NbPage = GetLastPageTxt(wind_targ)+1;
                      ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                      Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                     }
                  UpdateLghNbLgn(w_ind, object, 1);
                  RedrawPrintMiniPage();
                 }
             }
             break;                  
        } /* endswitch(ob_ind)  */     
     Evnt->evnt &= ~MU_KEYBD;                   
    } 
    
 /*.......................... Rpondre  l'vnement MU_BUTTON .........*/ 
 if (Evnt->evnt & MU_BUTTON)
    {int ob_ret; 
     ob_ret = Xform_button(w_ind, Evnt); 
     if (ob_ret>-1)
        {Evnt->evnt &= ~MU_BUTTON;
         /*.......... si objet type fleche haute ou basse ......................*/
         /*           c'est une icone dont le pere est une G_BOXTEXT            */
         if (GET_XOBTYPE(object, ob_ret)==G_CICON)
            {int ob_father  = FindParentOfObject(object, ob_ret);
             if (ob_father != -1 && GET_XOBTYPE(object, ob_father)==G_FBOXTEXT)
                {/*............ rechercher celui le plus  gauche ..............*/
                 /*                 c'est le decrementeur                       */
                 char buft[64];
                 int val = atoi(ObjcGetTxt(object, ob_father));
                 SetFocus(w_ind, Evnt, object, ob_father);
                 
                 do {if (object[ob_ret].ob_x <20)
                       {val = Max(0,val-1);
                       }
                     else
                       {val = Min(10000,val+1);
                       }
                     ObjcSetTxt(object, ob_father,  itoa(val, buft,10));
                     Wobjc_draw(w_ind, object, ob_father, 2, 0);
                    }  while(Mousek());
                 object[ob_ret].ob_state &= ~SELECTED;
                 Wobjc_draw (w_ind, object, ob_ret, 1, 0);
                 /*..... activer le temps reel selon objet clique ....*/
                 switch (ob_father)
                   {case PRT_SIZE_FONT:
                         WSetCursObEditOff(w_ind, 0);
                         PrtSizeFont  = Max(6, Min(120, val));
                         ObjcSetTxt(object, ob_father,  itoa(PrtSizeFont, buft,10));
                         Wobjc_draw(w_ind, object, ob_father, 2, 0);
                         NbLgnParPage = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                         /*....... actualiser le nombre de pages ......*/
                         if (wind_targ != -1)
                            {NbPage = GetLastPageTxt(wind_targ)+1;
                             ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                             Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                             if (PtPage > NbPage)
                                {PtPage = NbPage;
                                 ObjcSetTxt (object, PRT_PG_TXTCADR, ltoa(PtPage+1, buft,10));
                                 Wobjc_draw (w_ind, object, PRT_PG_TXTCADR, 1, 0); 
                                }
                            }
                         UpdateLghNbLgn(w_ind, object, 1);
                         RedrawPrintMiniPage();
                         break;
                    case PRT_PG_TXTCADR:
                         WSetCursObEditOff(w_ind, 0);
                         PtPage = Max(0, Min (val - 1 , GetLastPageTxt(wind_targ)));
                         ObjcSetTxt(object, ob_father,  ltoa(PtPage+1, buft,10));
                         Wobjc_draw(w_ind, object, ob_father, 2, 0);
                         RedrawPrintMiniPage();
                         break;
                   } 
                } /* endif (ob_father != -1 && GET_XOBTYPE(object, ob_father)==G_FBOXTEXT) */
            } /* endif (GET_XOBTYPE(object, ob_ret)==G_CICON) */
         /*.............. ICI ACTION SELON BOUTON CLIQUE..............*/            
         switch (ob_ret)            
            {/*..................... onglet fenetre ..................*/
             case PRT_PAINTBOX_RED:
             case PRT_PAGEPAINTBOX:
                  if (wind_targ != -1)
                     {TXTED_OB  *TXT_A  = WTXT_A(wind_targ);
                      long pos;
                      int param[16];
                      EZ_ED_GraphUpdate(TXT_A);
                      NbLgnParPage  = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                      pos           = Min( NbLgnParPage * PtPage, TXT_A->NbLgn -1);
                      pos           = (long)TXT_A->TabLgnCtx[pos].ptTxt;
                      TXT_A->CarPt  = 0;
                      *(long*) &param[0] = (long)pos;  
                      *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
                      EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
                      EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
                     }
                  break;
             case PRT_SAV_HEAD:
             case PRT_SAV_FOOT:
                 {char path[MAX_PATH];
                  char *nom;
                  /* char *src; */
                  GetPathRsc(GETWINDRSC(w_ind), path);
                  PathNomToNomFic(path, 0);
                  if (ob_ret==PRT_SAV_HEAD)
                     {nom = "EZ_HEAD.TXT";
                      /* src =ObjcGetTxt(object,PRT_HEADEDIT); */
                     }
                  else
                     {nom = "EZ_FOOT.TXT";
                      /*src =ObjcGetTxt(object,PRT_FOOTEDIT); */
                     }
                 EZ_ED_SaveTxt(path, nom, TXT_SAVE, EZ_ED_GetTxtEditStruct(object,PRT_FOOTEDIT));
                  /*Bsave(path, nom, src, strlen(src)+1);*/
                  object[ob_ret].ob_state &= ~SELECTED;
                  SendObjectRedraw(w_h, object, ob_ret);
                 }
                  break;
             case PRT_CHK_COLOR:
                  IsPrtColor = 0;  
                  if (object[PRT_CHK_COLOR].ob_state & SELECTED)
                     {IsPrtColor = 1;
                     }
                  RedrawPrintMiniPage();
                  break;
             case PRT_CHK_HEAD:
                  PrtHead = 0;  
                  if (object[PRT_CHK_HEAD].ob_state & SELECTED)
                     {PrtHead = 1;
                     }
                  RedrawPrintMiniPage();
                  break;
             case PRT_CHK_FOOT:
                  PrtNoteFoot = 0;  
                  if (object[PRT_CHK_FOOT].ob_state & SELECTED)
                     {PrtNoteFoot = 1;
                     }
                  RedrawPrintMiniPage();
                  break;
             case PRT_DRV_INFO: 
                  TesteDriver(DrvSel,DrvInf);
                  AdaptPgPAINTBOXtoResXetY(object, PRT_PAGEPAINTBOX, &PgGrect, DrvSel); 
                  AdaptPgPAINTBOXtoResXetY(object, PRT_PAINTBOX_RED, &PgGrect, DrvSel);
                  SetInfoDrvStr(object, PRT_DRV_INFO,DrvSel);
                  Xobjc_draw (object, PRT_DRV_INFO, 1, 0); 
                  Xobjc_draw (object, PRT_DRV_SCROLBOX, 1, 0);
                  NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                  UpdateLghNbLgn(w_ind, object, 1);
                  /*....... actualiser le nombre de pages .........*/
                  if (wind_targ != -1)
                     {NbPage = GetLastPageTxt(wind_targ)+1;
                      ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                      Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                     }
                  break;
             case PRT_PRINT_ALL:
             case PRT_IMPRIMER:
                  TesteDriver(DrvSel,DrvInf);
                  AdaptPgPAINTBOXtoResXetY(object, PRT_PAGEPAINTBOX, &PgGrect, DrvSel); 
                  AdaptPgPAINTBOXtoResXetY(object, PRT_PAINTBOX_RED, &PgGrect, DrvSel);
                  SetInfoDrvStr(object, PRT_DRV_INFO,DrvSel);
                  if (object[PRT_ONG_IMPRIME].ob_flags & HIDETREE)    
                     {RedrawPrintMiniPage(); 
                     }
                   else
                     {Wobjc_draw (w_ind, object, PRT_DRV_INFO, 1, 0);
                     }   
                  object[ob_ret].ob_state &= ~SELECTED;
                  Wobjc_draw (w_ind, object, ob_ret, 1, 0);
                  {int deb, end, nb;
                   int wind_targ  = IsWindExist(CurIDDoc); 
                   strcpy( buft, ObjcGetTxt (object, PRT_PG_DEB) );
                   deb = atoi( LedNumbertoAsciiNumber(buft));
                   strcpy( buft, ObjcGetTxt (object, PRT_PG_END) );
                   end = atoi( LedNumbertoAsciiNumber(buft));
                   strcpy( buft, ObjcGetTxt (object, PRT_NB_EXPL) );
                   nb = atoi( LedNumbertoAsciiNumber(buft));
                   /*........... si bouton imprimer tout ............*/
                   if (ob_ret==PRT_PRINT_ALL)
                      {deb = 1;
                       end = (int)GetLastPageTxt(wind_targ)+1;
                      }
                   /*.......... si onglet cadrage ....................*/                      
                   else if (!(object[PRT_ONG_CADRAGE].ob_flags & HIDETREE) ||
                            !(object[PRT_ONG_REDUIRE].ob_flags & HIDETREE)
                           )
                      {strcpy( buft, ObjcGetTxt (object,PRT_PG_TXTCADR  ) );
                       end = deb = atoi( LedNumbertoAsciiNumber(buft));
                      }                      
                   
                   if (wind_targ != -1) ImprimerPage (wind_targ, DrvSel, deb-1, end-1, nb);
                  }
                  break;
             case PRT_LST_FONT:
                 {int i           = GetSelectedListBoxItem(object, PRT_LST_FONT);
                  VdiFntId        = (int) FontID[i];
                  NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                  UpdateLghNbLgn(w_ind, object,1);
                  RedrawPrintMiniPage();
                  /*....... actualiser le nombre de pages .........*/
                  if (wind_targ != -1)
                     {NbPage = GetLastPageTxt(wind_targ)+1;
                      ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                      Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                     }
                 }
                  break;
             
             case PRT_DRV_SCROLBOX:
                  {int i, lgn_sel;
                   GetScrollBoxParam(object, ob_ret,0,0,0,0,0,0,&lgn_sel,0,0,0); 
                   i = (int)XYToScrollBoxItem(object, ob_ret, Evnt->x, Evnt->y);
                   if (i != lgn_sel)
                      {SetScrollBoxParam(object, ob_ret,-2,-2,-2,-2,-2,-2,i,-2,(void*)-2,-2);
                       Xobjc_draw(object, ob_ret, 1, 0);
                       SetInfoDrvStr(object, PRT_DRV_INFO,i);
                       Xobjc_draw (object, PRT_DRV_INFO, 1, 0);                       
                       DrvSel = i; 
                       AdaptPgPAINTBOXtoResXetY(object, PRT_PAGEPAINTBOX, &PgGrect, DrvSel);
                       AdaptPgPAINTBOXtoResXetY(object, PRT_PAINTBOX_RED, &PgGrect, DrvSel);
                       NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                       UpdateLghNbLgn(w_ind, object, 1);
                       /*....... actualiser le nombre de pages .........*/
                       if (wind_targ != -1)
                          {NbPage = GetLastPageTxt(wind_targ)+1;
                           ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                           Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                          }
                      }
                  } 
                  break;     
            } /* end switch ob_ret */
        }
    }
 
 /*.......................... TIMER ..................................*/  
 /* Dans le cadre d'une ressource en fenetre la fonction: Xform_timer */
 /* s'occupe de tout ce que doit gerer le timer notamment le clignote */
 /* ment du curseur texte dans les champs editables                   */
 if (Evnt->evnt & MU_TIMER)  
    {int wh_top;                    /* handle fenetre en avant plan     */
     wind_get( 0, WF_TOP, &wh_top); /* recuperer handle fen. avt plan.  */
     if (Windtab[w_ind].w_h == wh_top) Xform_timer(w_ind, Evnt);    
    }
 
 /*..........................Rpondre  l'vnement MU_MOVE ..............*/
 /* L'vnement MU_MOVE se manifeste chaque fois que la souris a modifie  */
 /* sa position. L'appel  la fonction: Xform_mu_move() permet de traiter */
 /* tout ce qui concerne un mouvement souris au dessus d'une ressource en */
 /* fenetre (ce n'est pas le cas ici) et le mouvement de la souris au     */
 /* dessus des bords de la fenetre (cas de notre exemple).                */ 
 if (Evnt->evnt & MU_MOVE)   /*  (EZGEM evenement)   */
    {Xform_mu_move(w_ind, Evnt);
    }           
 
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 /* L'vnement MU_MESAG se manifeste chaque fois qu'EAZY_GEM demande    */
 /* la fonction de fenetre de rpondre  un message. ci_dessous nous      */
 /* allons rpondre aux messages concernant notre fenetre.                */
   
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {
        case WM_CONSTRUCT:
             if (Gdos == -2) 
                {form_alert(1, TxtPtStrMess[ALR_GDOS_NOT]);
                 return WM_ABORT;
                }
                
             dlg->AdrRsc = LoadAppliRsc( "EZ_PRINT.RSC", NO_SCALE);              
             if (dlg->AdrRsc)                                            
                {/*....... integrer l'arbre de ressource ......*/
                 dlg->type     = RSC_DIAL;  /* TOOL_BAR; */
                 dlg->NumTree  = 0;                 
                 if (Xform_construct(w_ind, Evnt) == WM_ABORT) return WM_ABORT;
                 /*........... placer le tout sous la souris ..............*/
                 AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
                 if (NbDrv==0) 
                    {form_alert(1000, TxtPtStrMess[ALR_DRV_FIND]);                          
                     ExeAllMessage();
                     NbDrv = Analyse_ASSIGN(DrvInf);
                     WindAlertClose();
                    }
                 object=dlg->tree;
                 SetFntListBoxMode(object, PRT_LST_FONT,  IsViewFntReel);
                 /*........ relever dim PAINT_BOX ici ......................*/
                 /*         car cette valeur n'est bonne qu'au              */
                 /*         demarrage et qu'ensuite le programme se sert    */
                 /*         des dim deja existantes                         */
                 PgGrect = *(GRECT*)&object[PRT_PAGEPAINTBOX].ob_x;
        case WM_PRT_PRM_CHG:
                 if (NbDrv && Gdos !=-2)
                    {int fstl,nbcase;
                     long i;
                     
                     object[PRT_MRG_TOP_LEFT]. ob_flags      |= HIDETREE; 
                     object[PRT_MRG_TOP_RIGH].ob_flags       |= HIDETREE;  
                     object[PRT_MRG_LEFT_SUP].ob_flags       |= HIDETREE;  
                     object[PRT_MRG_LEFT_INF]. ob_flags      |= HIDETREE;
                     /*.......... adapter ScrollBox au driver selectionne ......................*/
                     DrvSel = Min(DrvSel,NbDrv-1);
                     SetListCallBackFunc (object, PRT_DRV_SCROLBOX, CallBackScrollDrv); 
                     GetScrollBoxParam(object, PRT_DRV_SCROLBOX,0,0,0,0,0,0,0,0,0L,&nbcase);
                     fstl = Min(DrvSel, NbDrv - 1 - nbcase);
                     SetScrollBoxParam(object, PRT_DRV_SCROLBOX,-2,-2,NbDrv,-2,fstl,-2,DrvSel,-2,0L,-2);
                     VascHeightAdjust(object, PRT_DRV_SCROLBOX, PRT_DRV_BAR, PRT_DRV_SLIDE);
                     object[PRT_CHK_COLOR].ob_state &= ~SELECTED; 
                     if (IsPrtColor) object[PRT_CHK_COLOR].ob_state |= SELECTED; 
                     /*..................  mise a jour entete ..................................*/
                     object[PRT_CHK_HEAD].ob_state &= ~SELECTED; 
                     if (PrtHead) object[PRT_CHK_HEAD].ob_state |= SELECTED; 
                     object[PRT_CHK_FOOT].ob_state &= ~SELECTED; 
                     if (PrtNoteFoot) object[PRT_CHK_FOOT].ob_state |= SELECTED;
                     
                     /* ObjcSetTxt (object, PRT_PG_STR, sHead); */
                     /*..................  mise a jour marges ..................................*/                     
                     ObjcSetTxt (object, PRT_MRG_LEFT,   AsciiNumberToLedNumber(itoa(MrgLeft,   buft,10)) );
                     ObjcSetTxt (object, PRT_MRG_TOP,    AsciiNumberToLedNumber(itoa(MrgTop,    buft,10)) );
                     ObjcSetTxt (object, PRT_MRG_RIGHT,  AsciiNumberToLedNumber(itoa(MrgRight,  buft,10)) );
                     ObjcSetTxt (object, PRT_MRG_BOTTOM, AsciiNumberToLedNumber(itoa(MrgBottom, buft,10)) );
                     /*..................  mise a jour info driver .............................*/
                     SetInfoDrvStr(object, PRT_DRV_INFO, DrvSel);                     
                     /*.......... positionner listbox de fonte par defaut...........*/
                     i               =  FontNameToFontID(PrtFontName, FontTab);
                     i               =  Max(0,i);
                     VdiFntId = (int) FontID[i];
                     SetListBoxParam(object, PRT_LST_FONT,(int)i,(int)i,-2,-2,-2,(void*)-2L);
                     ObjcSetTxt (object, PRT_SIZE_FONT, itoa(PrtSizeFont, buft, 10) );
                     NbLgnParPage    = (int) GetNbLgnParPageTxt(DrvSel, &Prt_Intl);
                     UpdateLghNbLgn(w_ind, object, 0);
                     
                     /* ............ adapter PaintBox au format de page........................ */
                     AdaptPgPAINTBOXtoResXetY(object, PRT_PAGEPAINTBOX, &PgGrect, DrvSel);
                     AdaptPgPAINTBOXtoResXetY(object, PRT_PAINTBOX_RED, &PgGrect, DrvSel);
                     if (Evnt->pipe[MESG] == WM_PRT_PRM_CHG)
                        {SendWindRedraw(GETGEMHAND(w_ind));
                        }
        case WM_ACT_TXT_CHG:
                     /*....... actualiser le nombre de pages .........*/
                     if (wind_targ != -1)
                        {NbPage = GetLastPageTxt(wind_targ)+1;
                         ObjcSetTxt (object, PRT_NB_PAGES, ltoa(NbPage, buft,10));
                        }
                     if (CurPrtDoc != CurIDDoc)
                        {int wind_targ  = IsWindExist(CurIDDoc); 
                         PtPage =Min( Max(0,PtPage), GetLastPageTxt(wind_targ));
                         ObjcSetTxt (object, PRT_PG_TXTCADR, ltoa(PtPage+1,buft,10) );
                         /*......... redessiner si besoin ...........*/
                         if (Evnt->pipe[MESG] == WM_ACT_TXT_CHG)
                            {UpdateLghNbLgn(w_ind, object, 1);
                             RedrawPrintMiniPage();
                             Wobjc_draw (w_ind, object, PRT_NB_PAGES, 1, 0);
                            }
                         }
                     CurPrtDoc      = CurIDDoc;
                    }
                 else
                    {Xform_Destruct(w_ind, Evnt);
                     return WM_ABORT;
                    }                                     
                }        /* endif (dlg->AdrRsc)  */                      
             else
                {return WM_ABORT;
                } 
             break;
                          
        case WM_DESTRUCT:
             {Xform_Destruct(w_ind, Evnt);
              RscFicUnLoad(dlg->AdrRsc); 
             }
             break;  
        case WM_MOUSEWHEEL:       Xform_WheelButton(w_ind, Evnt, 2);                  break;
        case WM_REDRAW: 
             /**************************************************************/              
             /*........................ WM_REDRAW (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* il faut redessiner une partie de la fenetre (par exemple un*/
             /* accessoire qui la recouvrait vient de se fermer, il faut   */
             /* alors retracer la partie de notre fenetre que l'accessoire */
             /* recouvrait. Avant c'etait un veritable enfer, maintenant   */
             /* il vous faut juste appeler la routine: Lister_rectangles   */
             /* qui vous renvoie le message WM_PAINT                       */
             /* et vous n'avez plus  vous occuper de savoir comment faire */
             /* notamment pour traiter la liste des rectangles et leur     */
             /* intersection avec notre fenetre.                           */                               
             Lister_rectangles(Windtab[w_ind].w_h,(GRECT*)&Evnt->pipe[X_G]);                                       
             break;     
             
        case WM_PAINTBOX:
            {GRECT grect, clip_grect;
             grect = *(GRECT*)&Evnt->pipe[X_B];
             Evnt->pipe[W_B]-=2;
             Evnt->pipe[H_B]-=2;
             vswr_mode(VDIhandle,MD_REPLACE);
             DrawReliefCadre((GRECT*)&Evnt->pipe[X_B], -1, 8,4);
             grect.g_x += 5;
             grect.g_y += 4;
             grect.g_w -= 10;
             grect.g_h -= 9;
             clip_grect = grect;               
             
             if (Rc_intersect((GRECT*)&Evnt->pipe[X_G], &clip_grect))
                {ClipGrect(&clip_grect); 
                 if (Nb_plan<4) 
                    {Deffill(0,0,0);  
                     GrectPbox(&grect);
                    }                  
                 Defline(1,1,0,0,1);                             
                 
                 switch (Evnt->pipe[12])
                    {case PRT_PAGEPAINTBOX:   
                     case PRT_PAINTBOX_RED:       
                         {int wind_targ  = IsWindExist(CurIDDoc);
                          if (wind_targ != -1) LirePage(wind_targ, VDIhandle, (int)PtPage, &grect);
                         }
                          break;
                     case 2:                        
                          break; 
                     case 3:
                          break;         
                    }                  
                } /* endif Rc_intersect((GRECT*)&Evnt->pipe[X_G], &clip_grect) */                             
             }   
             break;                        
                     
        case WM_CLOSED: 
             /**************************************************************/     
             /*........................ WM_CLOSED (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre         */
             /* lorsqu'une demande de fermeture de la fenetre est demandee */
             /* si vous voulez detruire completement cette fenetre il faut */
             /* appeler imperativement la fonction: DestroyWindow          */
             /* pour la reouvrir ensuite il vous faudra appeler la         */
             /* fonction:                           CreateWindow           */
             /* sinon il vous faut faire un simple: CloseWindow  et la     */
             /* reouvrir par:                       OpenWindow             */
             /* sans etre oblige de tout reinitialiser                     */
             /* CloseWindow(w_ind);                                        */             
             DestroyWindow(Windtab[w_ind].w_h);             
             break;
             
        case WM_TOPPED:      wind_set(w_h, WF_TOP );                          break;
        case WM_BOTTOM:      wind_set(w_h, WF_BOTTOM );                       break;
        case WM_TT_ON_OFF:   SetBulleState(w_h, dlg->tree);                   break;
        case WM_MOVED:       OnWm_moved(w_ind, Evnt);                         break;
        case AP_TERM:        EZGemRun=-1;                                     break;
        case WM_ALLICONIFY:  AllIconify((GRECT*)& Evnt->pipe[X_G]);           break;
        case WM_ICONIFY:     IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]); break;
        case WM_UNICONIFY:   UnconifyWindow(w_ind);                           break;
         
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}


/*--------------------------- RedrawPrintMiniPage -----------------------*/
void RedrawPrintMiniPage(void)
{int w_ind, w_h;
 OBJECT *object;
 w_ind = IsWindExist(W_EZ_EDIT_PRT);
 if (w_ind !=-1 && IsWindOpen(w_ind))
    { object = GETWINDTREE(w_ind);
      w_h = Windtab[w_ind].w_h;
     /* Wobjc_draw(w_ind, GETWINDTREE(w_ind), PRT_PAGEPAINTBOX, 5, 0); */
     if (!(object[PRT_ONG_CADRAGE].ob_flags & HIDETREE))
        {SendObjectRedraw(w_h, object, PRT_PAGEPAINTBOX);
         Wobjc_draw(w_ind, object, PRT_PG_TXTCADR, 1, 0);
         /*SendObjectRedraw(w_h, object, PRT_PG_TXTCADR);         */
        }                      
     if (!(object[PRT_ONG_REDUIRE].ob_flags & HIDETREE))    
        {SendObjectRedraw(w_h, object, PRT_PAINTBOX_RED);
         /* SendObjectRedraw(w_h, object, PRT_PG_TXTRED); */
        }
    }
}

/*--------------------------- SetInfoDrvStr--------------------------------*/
static void SetInfoDrvStr(OBJECT *object, int ob_ind, int i)
{char strtemp[64];
 char buft[32];
 strcpy(strtemp," L:");
 strcat(strtemp, itoa(DrvInf[i].ResX,buft,10));
 strcat(strtemp," H:");
 strcat(strtemp, itoa(DrvInf[i].ResY,buft,10));
 strcat(strtemp,"  Dpi X:");
 strcat(strtemp, itoa(DrvInf[i].PpiX,buft,10));
 strcat(strtemp," Y:");
 strcat(strtemp, itoa(DrvInf[i].PpiY,buft,10));
 strcat(strtemp,"  Vct:");
 strcat(strtemp, itoa(DrvInf[i].NbVect,buft,10));
 ObjcSetTxt (object, ob_ind, strtemp );
}

/*---------------------------- CallBackScrollDrv -------------------------*/
/* ACTION: routine affichant chaque ligne de la scrollbox des DRIVERS     */
/*                                                                        */
static int CallBackScrollDrv(SCROLLBOX_GET_AFFI *SCRL)
{GRECT Glgn,    /* rectangle pour les lignes   */
       clip_grect;

if (SCRL->LgnAff > -1)   /* Si Numero de ligne coherent        */
   {/*............. calcul du rectangle a afficher ............*/
    Glgn.g_x  = SCRL->Grect.g_x;
    Glgn.g_y  = GL2GI(SCRL->Grect.g_y +
                      SCRL->LgnH      *
                      SCRL->LgnAff);
    Glgn.g_w  = SCRL->Grect.g_w - 1;
    Glgn.g_h  = SCRL->LgnH      - 1;
    /*....... placez l les instructions de traage ...........*/
    /*                   de la ligne.                          */
    /*... si notre rectangle coincide avec celui de clipping...*/
    clip_grect = Glgn;
    if (Rc_intersect(&SCRL->ClipGrect,&clip_grect))
       {int i, tx, ty, fnt;
        ClipGrect(&clip_grect);   
        tx = Glgn.g_x;
        ty = Glgn.g_y + 5;
        vst_alignment (VDIhandle,0,ALI_TOP, &i, &i ); 
        i  = GL2GI(SCRL->LgnAff + SCRL->FstLgn);        
        Graphmode(MD_REPLACE);
        fnt = vst_font(VDIhandle, SCRL->VDIFntID);
        /*........... Si c'est la ligne selectionnee ..........*/
        /*            dessiner rectangle blanc                 */
        if (i == SCRL-> LgnSel)   /*  */     
           {/*... Si fonte Vectorielle, le rectangle doit etre plus bas....*/
            if (fnt  >1 ) Glgn.g_y += 5;            
            Glgn.g_h -= 2; 
            Deffill(1,0,0);
            GrectPbox(&Glgn);            
           }   
        Graphmode(MD_TRANS);    
        Deftext(SCRL->Col,0,0,SCRL->Pts,-1); 
        v_gtext(VDIhandle,tx + 20, ty , DrvInf[i].sDrvName);
        vst_color(VDIhandle,2);
        v_gtext(VDIhandle,tx ,  ty , DrvInf[i].sDevNum);               
       }
   }   
 return 1;
}

/*----------------------------- AdaptPgPAINTBOXtoResXetY ----------------------*/
/* ACTION: redimenssione les objets de vue reduite selon format de page driver */

int AdaptPgPAINTBOXtoResXetY(OBJECT *object, int ind_ob, GRECT *pggrect, int drv)
{int w,h;
 /*............ on prend h fixe .................*/
 h =  pggrect->g_h;
 w =  (int)((float)((float)DrvInf[drv].ResX * (float)pggrect->g_w) /(float)DrvInf[drv].ResY) ;
 if (w>pggrect->g_w)  /* si largeur plus grande que hauteur */
    {/*....................  on prend w fixe ...............*/
     w =  pggrect->g_w;
     h =  (int)((float)((float)DrvInf[drv].ResY*(float)pggrect->g_h)/(float)DrvInf[drv].ResX);
    }
 /*............. adapter ressource ............*/
 object[ind_ob].ob_width  = w;
 object[ind_ob].ob_height = h;
 object[ind_ob].ob_x  = pggrect->g_x +pggrect->g_w-w;
 object[ind_ob].ob_y =  pggrect->g_y +pggrect->g_h-h;
 return 1;
}

/*------------------------------ ScanDrivers -----------------------------*/
/* ACTION: Scane tous les drivers VDI et rempli une structure avec:       */
/*         leur nom, resolution X & Y,                                    */
/* ENTREE: int *nb_drv; est retourne dans cette variable le nombre de     */
/*                      drivers pointes                                   */
/* SORTIE: DRVINF *pointe sur une zone memoire reservee ou sont stockees  */
/*         les infos concernant les drivers dispo. Cette adresse est a    */
/*         liberer en fin de programme.                                   */ 

/* typedef struct
       {char            sDevNum[4];
        char            sDrvName[32];
        int             ResX;
        int             ResY; 
        int             PpiX;
        int             PpiY;    
        int             NumDev;
        } DRVINF;
*/
             
DRVINF *ScanDrivers(int *nb_drv)
{char buft[32];
 int p_in[11],p_out[57], p_sup[57];
 int devnum, devexist, test_handle;
 int i;
 
 for (i=1;i<10;p_in[i++]=1);
 p_in[10]=2;
 
 
 *nb_drv = 0;
 for ( devnum = 21 ; devnum <= 99 ; devnum++)    /* on va tester ts les No Gdos */
     {p_in[0] = devnum;         /* Numro du prif  tester */ 
      v_opnwk(p_in, &test_handle, p_out); /* ouvre la station de l'imprimante */  
      /*................. Si driver dispo pour ce numero ......................*/
      if (test_handle )                        
         {vqt_devinfo(test_handle, devnum, &devexist, DrvInf[*nb_drv].sDrvName);
          /*.............. si driver de sortie existe  ........................*/ 
          if (devexist && (devnum<=39 || devnum>=91))        
             {vq_extnd(test_handle,1,p_sup);
              DrvInf[*nb_drv].ResX   = p_out[0];
              DrvInf[*nb_drv].ResY   = p_out[1];
              DrvInf[*nb_drv].NbVect = p_sup[14];              
              DrvInf[*nb_drv].PpiX   = AdjustPtspar1000ToPPI(p_out[3]);
              DrvInf[*nb_drv].PpiY   = AdjustPtspar1000ToPPI(p_out[4]);
              DrvInf[*nb_drv].NumDev = devnum;
              if (((char)_VDIParBlk.ptsout[1] != 0) && ((char)_VDIParBlk.ptsout[1] != 255)) 
                 {strcpy(DrvInf[*nb_drv].sDrvName, (char *)&_VDIParBlk.ptsout[1]);
                 }
              else 
                 {DrvInf[*nb_drv].sDrvName[8]='\0';     /* supprime l'extension */
                 }
              strcpy(DrvInf[*nb_drv].sDevNum, itoa(devnum,buft,10));   
              *nb_drv +=1;    
             }      /* endif (devnum<=39 && devnum>=91 && devexist==1)  */
          v_clswk(test_handle);     
          if (devnum>=31 && devnum<=40) Fdelete(sGemFile); 
         }        /* endif ( test_handle)  */
      }          /* next devnum                                      */
 DrvInf[*nb_drv].ResX   = Ecran_l;
 DrvInf[*nb_drv].ResY   = 0;
 DrvInf[*nb_drv].NbVect = 512;              
 DrvInf[*nb_drv].PpiX   = 72;
 DrvInf[*nb_drv].PpiY   = 72;
 DrvInf[*nb_drv].NumDev = 10;  
 strcpy(DrvInf[*nb_drv].sDrvName, "SCREEN");
 strcpy(DrvInf[*nb_drv].sDevNum, "10");    
 return DrvInf;
}

/*-------------------- TesteDriver -----------------------------------------*/
/* ACTION: teste si le driver est valide en ouvrant une station de travail  */
/*         et si il est valide releve les caracteristiques du driver et     */
/*         ajuste le nom si vqt_devinfo() en retourne un.                   */
/*         sinon ne touche pas au nom.                                      */
/*         Sont mis a jour:                                                 */
/*                     drvinf[drv].ResX                                     */
/*                     drvinf[drv].ResY                                     */
/*                     drvinf[drv].NbVect                                   */
/*                     drvinf[drv].PpiX                                     */
/*                     drvinf[drv].PpiY                                     */
/*                     drvinf[drv].sDevNum                                  */
/*                     drvinf[drv].sDrvName (que si  vqt_devinfo() valide)  */
/*                                                                          */
/* ENTREE:  int drv: indice de la structure DRVINF  tester dans la table,  */
/*          DRVINF *drvinf: table de structure d'info sur les drivers.      */
/*          drvinf[drv].NumDev doit etre sur le bon numero de driver GDOS,  */
/*          avant l'appel (21 .... 30 etc)                                  */
/*                                                                          */
/* SORTIE:  1/ le driver fonctionne.                                        */
/*          0/ le driver est en panne.                                      */

int TesteDriver(int drv, DRVINF *drvinf)
{char buft[64];
 int p_in[11],p_out[57], p_sup[57];
 int devnum, devexist, test_handle;
 int i;
 devnum = drvinf[drv].NumDev;
 for (i=1;i<10;p_in[i++]=1);
 p_in[10]=2;
 p_in[0]  = devnum;
 devexist = 0;
 v_opnwk(p_in, &test_handle, p_out); /* ouvre la station de l'imprimante */  
 /*................. Si driver dispo pour ce numero ......................*/
 if (test_handle )                        
    {vq_extnd(test_handle,1,p_sup); 
     drvinf[drv].ResX         = p_out[0];
     drvinf[drv].ResY         = p_out[1];
     drvinf[drv].NbVect       = p_sup[14];              
     drvinf[drv].PpiX         = AdjustPtspar1000ToPPI(p_out[3]);
     drvinf[drv].PpiY         = AdjustPtspar1000ToPPI(p_out[4]);
     /*.............. si driver de sortie existe  ........................*/ 
     vqt_devinfo(test_handle, devnum, &devexist, buft);
     if (devexist)
        {/* drvinf[drv].NumDev = devnum; deja renseign    */
         if (Gdos == '_FSM')
            {if (((char)_VDIParBlk.ptsout[1] != 0) && ((char)_VDIParBlk.ptsout[1] != 255)) 
                {strcpy(drvinf[drv].sDrvName, (char *)&_VDIParBlk.ptsout[1]);
                }
             else 
                {buft[12]=0;
                 strcpy(drvinf[drv].sDrvName, buft);
                }                         
            }
        strcpy(drvinf[drv].sDevNum, itoa(devnum,buft,10));    
        }      /* endif (devexist==1)  */
    /*.............. Sinon prendre nom du ficher ASSIGN.SYS  .............*/      
     else
        {strcpy(drvinf[drv].sDevNum, itoa(devnum,buft,10));
        }
     v_clswk(test_handle);     
     if (devnum>=31 && devnum<=40) Fdelete(sGemFile); 
     return 1;
    }        /* endif ( test_handle)  */
 return 0;   
}

/*----------------------------- Releve_DRIVER ---------------------------*/
/* ACTION: analyse le fichier ASSIGN.SYS et teste les drivers indiques   */
/*         et rempli le tableau de driver avec ceux valides.             */
/* ENTREE: char *ptc: pointe sur premier driver du texte ASSIGN          */
/*                                                                       */
int Releve_DRIVER(char *ptc, DRVINF *drvinf)
{char word[64], drvname[64];
 int val,drvnum;
 int l = 0;
 drvnum = 0;
 do
  {ptc=ExtraitWord(word, ptc+l, &l);
   if (l && *word>='0' && *word<='9') /*..... si ligne de numero de periph ...*/ 
      {word[3]=0;                 /* ne retenir que les 3 premiers caractres */
       val=atoi(word);            /* 11-20 plotter 21-30 printer 31-40 mta   */
                                  /* 51-60 ??????  61-70 memoire 91-100 img   */  
       if ( ((val>=21  && val<=40) || (val>=91 && val<=100))  && drvnum<29)
          {drvinf[drvnum].NumDev = val;
           ptc=ExtraitWord(drvname, ptc+l, &l);   /* recuperer "FX_80.SYS"    */
           drvinf[drvnum].sDrvName[0] = 0;        /* effacer le nom du driver */
           /*......... tester driver indique par ASSIGN.SYS ..........*/
           if (TesteDriver(drvnum, drvinf))            
              {/*.......... si pas de nom on met celui ...........*/
               /*              qu'ASSIGN.SYS indique              */
               if (Gdos != '_FSM' || drvinf[drvnum].sDrvName[0]==0) 
                  {strcpy(drvinf[drvnum].sDrvName, drvname);
                   drvinf[drvnum].sDrvName[12]=0;
                  }               
               drvnum++;
              }  /* endif (TesteDriver(drvnum, drvinf))   */
          }  /* endif ( ((val>=21  && ....             */
      }  /* endif (l && *word>='0'...              */
  } while (l);   
 return(drvnum);
}

/*-------------------- AdjustPtspar1000ToPPI -------------------------------*/
/* ACTION: cette routine sert a corriger une erreur souvent due a une       */
/*         approximation de la valeur en 1/1000 mm d'un point imprimante    */
/*         qui est pour les resolutions elevees une valeur fractionnaire    */
/*         Le VDI ne permet pas en effet de rendre la taille d'un pixel de  */
/*         peripherique avec suffisamment de precision.                    */
int AdjustPtspar1000ToPPI(int pt_1000)
{int i, res_x;
   i=25400/pt_1000;            /* i      = 357 ou 362  ppi */
   res_x=10*(i/10);            /* dumy   = 350 ou 360  ppi */
   if ( abs(i-res_x) >= 5 )    /* i-dumy =   7 ou -2       */ 
        res_x+=10;             /* dumy   =        360  ppi */
   /*..... corriger pour les resolutions non multiples de 10 .....*/
   /* 72 91 120 144 180 196 300 360 600 720 1270 2540             */
   if (res_x == 70)  res_x = 72;
   if (res_x == 90)  res_x = 91;
   if (res_x == 140) res_x = 144;
   if (res_x == 200) res_x = 196;
   return res_x;
}

/*---------------------------- Analyse_ASSIGN ---------------------------*/
/* ACTION : analyse le fichier C:\ASSIGN.SYS, et                         */
/*         rempli: ->le tableau global char DRIVER[18*30] avec les noms  */
/*                   des drivers d'imprimante: "21 EPSON.SYS"            */
/*                 ->path ASSIGN_path avec le chemin des fontes et des   */
/*                   des drivers                                         */
/* RETOUR : nbr d'elements type drivers trouvs                          */

int  Analyse_ASSIGN(DRVINF *drvinf)
{char path[MAX_PATH];
 char word[MAX_PATH];
 char ASSIGN_path[MAX_PATH];
 long len_fic,i;
 int l,nbper;
 char *texte,*ptc;
 
 nbper=0;
 /*.................. former le chemin du fichier ASSIGN ................*/
 strcpy(path,"A:\\");            /* commencer par la chaine minimum      */
 l=Swpeek(0x446L);               /* relever le drive de boot systme     */
 path[0]=65+(char)l;             /* placer le drive de boot dans le PATH */
 strcpy(word,"ASSIGN.SYS");      /* nommer le fichier ASSIGN.SYS         */
 len_fic =  FicLen(path, word);  /* voir si il existe                    */
 if (len_fic>0)
    {texte=(char*)malloc(len_fic+1);    /* + 1 car rajouter zro de fin  */
     if (texte)
        {if (texte != Bload( path, word, texte))
            {ptc=texte;
             ptc[len_fic]=0;     /* rajouter zro de fin (plus scurit)  */
             ptc=ExtraitWord(word,ptc,&l);  /* relever le prem mot signi */
             word[4]=0;                  /* premier mot doit etre PATH   */
             strupr(word);               /* mettre en majuscule          */
             if (strcmp(word,"PATH")==0)
                {ptc=ExtraitWord(word,ptc+4,&l); /* rechercher signe =   */
                 if (*ptc == '=' && l)
                    {/* ...........rechercher A:\FONT\ ..................*/
                     ptc=ExtraitWord(ASSIGN_path, ptc+1, &l);
                     i=strlen(ASSIGN_path);
                     if (ASSIGN_path[i-1] != 92 )     /* si pas  \       */
                        {ASSIGN_path[i]    = 92;      /* le rajouter     */
                         ASSIGN_path[i+1]=0;          /* clore la chaine */
                        } 
                     /* ...........relever les drivers ..................*/
                     nbper=Releve_DRIVER(ptc+l, drvinf);
                    }
                 else
                    {/*Alert_message(32);*/  /* Fichier ASSIGN incorrect  =  */
                    }
                }
             else
                {/* Alert_message(31);*/  /* Fichier ASSIGN incorrect   PATH  */
                }
            }
         else                    /* else de Bload                        */                                   
            {/*Alert_message(29); */ /* erreur dans chargement ASSIGN        */
            }
         free(texte);
        }
     else                    /* else de allocation memoire               */
        {/*Alert_message(29);*/  /* erreur dans chargement ASSIGN            */
         /*Alert_message(30);*/  /* mmoire issufisante pour cette opration */     
        }  
    }
 else                    /*  else de if fic exist                    */ 
    {/* Alert_message(29);*/  /* erreur dans chargement ASSIGN            */
    }
 return(nbper);
}
  
/*----------------------------- Swpeek ----------------------------------*/
int Swpeek(long adr)
{long save_ssp;
 int mot;
 save_ssp=Super(0L);
 mot=*(int*)adr;
 Super((void*)save_ssp);
 return(mot);
}

/*----------------------------- ExtraitWord -----------------------------*/
/* ACTION : va j'usqu'au premier mot significatif et l'extrait           */

char *ExtraitWord( char *dest, char *ptr,int *nbr_car)
{int sortie=1;
 char *deb;
  
 *nbr_car=0;
 dest[0]=0;         /*............ annuler le mot retourn ..........*/
 while(sortie)      /*............ tant que pas de mot trouv .......*/
   {switch (*ptr)
           {case  0:        /*>>>>> sortir si EOF                   */
                  sortie=0;                 
                  break;    
            case  ';':      /*>>>>> avancer jusqu' ligne suivante  */
            case  10 :
            case  13 :
                  ptr=Ligne_suivante(ptr);  
                  break;    
            case  32:       /*>>>>> avancer tant que espace         */
                  while( *ptr==32)  ptr++;      
                  break;    
            default:        /*>>>>> recuperer le mot                */
                  deb=ptr;
                  while(*ptr != 0   && 
                        *ptr != 13  &&
                        *ptr != 10  &&
                        *ptr != ';' &&
                        *ptr != 32    ) ptr++;
                  *nbr_car=(int)(ptr-deb);
                  memcpy(dest,deb,*nbr_car);
                  dest[*nbr_car]=0;
                  sortie=0;
                        
            }   /*....... fin de switch ...*/
    } /*..... fin de while   ...*/
 return(deb);
}

/*---------------------------- Ligne_suivante ---------------------------*/
char *Ligne_suivante(char *ptr)
{while(*ptr != 10 &&          /* tant que pas de CR/LF ou EOF rencontr  */
       *ptr != 13 &&
       *ptr != 0     )ptr++;
 if (*ptr)                    /* si pas EOF sauter tout CR/LF            */
    {while(*ptr==10 || *ptr == 13) ptr++;
    }
 return(ptr);
}
